#include "mex.h"

#include <stdio.h>
#include <iostream>
#include <time.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
using namespace std;




/* the gateway function */
//la chiamata deve essere ptr=BuildTable()
//Errors flag:
// -2 Can not load table
// -1 Not enoguh memory
void mexFunction( int nlhs, mxArray *plhs[1],
                  int nrhs)
{
 
 //dichiarazioni variabili   
 int*HR;
 double* ptr; 
 
  if(nrhs!=0) 
    mexErrMsgTxt("No inputs required.");
  if(nlhs!=1) 
    mexErrMsgTxt("Only one Output Supported");
  
       
    //Crea l'output e attaccalo al punatore in uscita
     plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
      ptr = mxGetPr(plhs[0]);
  
    HR=new int[32487834];
    if(HR==NULL)
    {
		 mexErrMsgTxt("Not enough memory to load table\n");
	    *ptr=-1;
	    
		return;
	}

    //	printf("Loading HandRanks.DAT file...");
//     mexPrintf("sizeof(HR): %4.1d \n",sizeof(HR));
    
    int HRsize=32487834*4;//the size of the table
	memset(HR, 0, HRsize);
	FILE * fin = fopen("HandRanks.dat", "rb");
	if (!fin)
	{
	    mexErrMsgTxt("Can not load table\n");
	    *ptr=-2;
		return;
	}
	size_t bytesread = fread(HR, HRsize, 1, fin);	// get the HandRank Array
	fclose(fin);
	//mexPrintf("Table Loaded\n");
      
//     mexPrintf("HR: %4.1d \n",HR[0]);   
//     mexPrintf("HR: %4.1d \n",HR[100]); 
//      mexPrintf("HR: %4.1d \n",HR[1000]); 
//      mexPrintf("HR: %4.1d \n",HR[10000]); 
    
     *ptr=(long) HR;//copia il puntatore 
     ptr = mxGetPr(plhs[0]);
     
     
     //trying to remake it a tree pointer
     // verifico se la conversione riporta al puntatore originario
     //ptr=(GLTREE*)(long(ptrtree[0]));
    // mexPrintf("puntatore= %4.4x\n",ptr);
  
     
     
}




        
